!!if .PluginComponent.Spec.IsGenerationPlugin
!!pathreplace PLUGINNAME {{.PluginComponent.Spec.PluginName}}
{{ NonEditableFileHeader | ToGoComment }}

package {{.PluginComponent.Spec.PluginName | ToGoPackageName}}

import (
	"os"

	. "github.com/onsi/ginkgo/v2"
	. "github.com/onsi/gomega"
	"{{.GoModule}}/pkg/{{.PluginComponent.Spec.PluginName}}/templates"
    "code.cestus.io/libs/codegenerator/pkg/templating"
	"code.cestus.io/tools/fabricator/pkg/fabricator"
)

var _ = Describe("Generation", func() {
	It("Generates", func() {
		ctx := context.Background()
		packProvider := templating.NewPackProvider()
		packProvider.RegisterProvider(templating.NewEmbededPackProvider(templates.GetTemplates()))
		io := fabricator.NewTestIOStreamsDiscard()
		file, err := os.Open("./testdata/deserialize.yml")
		Expect(err).ToNot(HaveOccurred())
		config, err := LoadPluginConfig(file)
		Expect(err).ToNot(HaveOccurred())
		root, err := os.MkdirTemp("./testdata", "generation")
		Expect(err).ToNot(HaveOccurred())
		plugin, err := newPlugin(ctx, io, config, root, packProvider)
		Expect(err).ToNot(HaveOccurred())
		err = plugin.Generate(ctx, io)
		Expect(err).ToNot(HaveOccurred())
		err = os.RemoveAll(root)
		Expect(err).ToNot(HaveOccurred())
	})
})